; #########################################################################
; Ce code source est donn  titre purement INFORMATIF, tel quel et je dcline 
; toutes responsabilits quand  l'utilisation que vous pourriez en faire.  
; Il est destin  apprhender l'accs aux plugin PhotoFiltre en assembleur.
; Il n'est pas optimis et ne vrifie aucun retour de fonction. 
; Vous pouvez le modifier  votre convenance.
; ATTENTION : NECESSITE la version 5.6 MINIMUM de PhotoFiltre qui est disponible sur le site
; http://www.photofiltre.com/  (Copyright 2001-2004 Antonio Da Cruz)
; Voir sur le site: Plugins->Autorisation de dveloppement
; #########################################################################

      .386
      .model flat, stdcall  ; Model mmoire Windows 32
      option casemap :none  ; Case sensitive

      include Demo.inc     	
			include PhotoFiltre.inc
;********************************************************************
; PROTOTYPES
;********************************************************************
DllEntry 		PROTO :DWORD,:DWORD,:DWORD
DlgCreate   PROTO :DWORD,:DWORD
DialogProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD
Affiche			PROTO 
szCopyStr 	PROTO :DWORD,:DWORD
;-------------------------------------------------------------------------

;********************************************************************
; CONSTANTES BOITE DE DIALOGUE
;********************************************************************
IDC_BUTTON1				EQU		101	; Annuler
IDC_BUTTON2				EQU		102	; Ok
IDC_CHECKBOX1			EQU		105	; Rouge
IDC_CHECKBOX2			EQU		106	; Vert
IDC_CHECKBOX3			EQU		107	; Bleu

;********************************************************************
.DATA
;********************************************************************
;-------------------------------------------------------------------------
; SPECIFIQUES PhotoFiltre
;-------------------------------------------------------------------------
ALIGN 4
PStruct						PluginStruct	<>
ALIGN 4
PHeader						PluginHeader	<>


HeaderCaption				db	"Demo Filtre (asm)",0
HeaderVersion				db	"Version 2.0",0
HeaderAuthor				db	"P@F",0
HeaderCommentaire		db	"Conserve ou efface les couches R-V-B.",10,13
										db	"Plugin de test crit en Assembleur.",10,13
										db	"Ncessite PhotoFiltre 5.6 minimum.",0
HeaderPluginType		dd	PT_FILTER
HeaderPluginFlag		dd	MF_RGB_COLORS + MF_NEED_IMAGE

;-------------------------------------------------------------------------
; Specifique PlugIn
;-------------------------------------------------------------------------
Img								SIMAGE	<>		; TBitmap DELPHI = Image Source

hInstance						dd 	0							; Intance du PlugIn
hDlg								dd	0							; Handle de la boite de dialogue
hPhotoFiltre				dd 	0							; Handle de PhotoFiltre.exe
Str1							 	db 	128 dup(?)		; Chaine D'usage general

Couche							dd	0							; Masque de couche 
RetValue						dd	0							; Retour de la boucle de message
IsInit							dd	0

CHECKBOX1						dd 	0							; Handle ChekBox Rouge
CHECKBOX2						dd 	0							; Handle ChekBox Vert
CHECKBOX3						dd 	0							; Handle ChekBox Bleu



; ########################################################################
; POINT D'ENTREE DU PLUGIN
; ########################################################################
.code
DllEntry 				proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	
	;== PROCESS ATTACH =========================================
	.if reason == DLL_PROCESS_ATTACH
		push 				hInst								; hInstance d'appel
		pop 				hInstance						; Sauvegarde
		
		;== Initialisation du PlugInHeader =========================================
		invoke			RtlZeroMemory,addr PStruct,sizeof(PluginStruct)
		invoke			RtlZeroMemory,addr PHeader,sizeof(PluginHeader)
  	invoke			RtlZeroMemory,addr Img,sizeof(SIMAGE)
		invoke 			szCopyStr,addr PHeader.Caption,addr HeaderCaption
		invoke 			szCopyStr,addr PHeader.Version,addr HeaderVersion
		invoke 			szCopyStr,addr PHeader.Author,addr HeaderAuthor
		invoke 			szCopyStr,addr PHeader.Commentaire,addr HeaderCommentaire
  	m2m					PHeader.PluginType,HeaderPluginType
		m2m					PHeader.Flags,HeaderPluginFlag
		return	1
	.endif
	
	return	0
DllEntry 			Endp


; ########################################################################
; FONCTION : EXECUTE
; ########################################################################
Execute proc uses esi edi
LOCAL Err:DWORD


;== Test la validit de version PhotoFiltre =========================================
			.if (PStruct.PrepareDialogue == 0)
				return 0
			.endif

    ;== Forcer Vars a zero ============================
			mov			Err,0											; Init Code Erreur retour

		;== Recupere le Handle de PhotoFiltre =========================================
			m2m			hPhotoFiltre,PStruct.MainHandle

  	;== Debut de l'execution du plugin =========================================
			TBeginFilter offset HeaderCaption,dFALSE	; Lance l'execution    
    	
    	;== Activation de L'interface Visuelle ============================
			invoke 	DlgCreate,hInstance,NULL
    	
    	;== Test Ret Visuel ============================
			or			eax,eax
			je			NoAppFilter	; Si Ret Visuel = 0 => On passe
			mov			Err,1				; Si Ret Visuel = 1 => Signaler la modif
	
    	;== Libere le bitmap Delphi  ============================
NoAppFilter:
			cmp			Img.piBitmap,0
			je			EndFilter
			TFreeDBmp Img

    	;== Fin Du Filtre, Retourne Err ============================
EndFilter:
			TEndFilter
			return	Err

FinErreur:
			return	0
Execute endp
;-------------------------------------------------------------------------

;========================================================================
; DlgCreate
; Affichage de la boite de dialogue
;========================================================================
DlgCreate PROC hInst,hParent
szText DlgNum,"DIALOG_1"

	invoke 	DialogBoxParam,hInst,addr DlgNum,hParent,addr DialogProc,NULL  
	ret			

DlgCreate endp
;-------------------------------------------------------------------------

;========================================================================
; DialogProc
; Boucle de message de la boite de dialogue
;========================================================================
DialogProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg == WM_INITDIALOG
    	
    	;== Forcer TBitmap Delphi et autres Vars a zero ============================
			m2m			Img.piBitmap,0
			mov			Couche,0
			mov			IsInit,0									; Affichage interdit
			mov			RetValue,0
			m2m			hDlg,hWin

    	;== Init DIALOGBOX ============================
    	invoke 	LoadIcon,hInstance,500
    	invoke 	SendMessage,hWin,WM_SETICON,ICON_BIG,eax
    	mov			RetValue,0
			
     	;== Init CHECKBOX ============================
    	invoke	GetDlgItem,hWin,IDC_CHECKBOX1	; Rouge
    	mov			CHECKBOX1,eax
    	invoke	GetDlgItem,hWin,IDC_CHECKBOX2	; Vert
    	mov			CHECKBOX2,eax
    	invoke	GetDlgItem,hWin,IDC_CHECKBOX3	; Bleu		
    	mov			CHECKBOX3,eax
    	invoke 	SendMessage,CHECKBOX1,BM_SETCHECK,BST_CHECKED	,0		
    	invoke 	SendMessage,CHECKBOX2,BM_SETCHECK,BST_CHECKED	,0		
    	invoke 	SendMessage,CHECKBOX3,BM_SETCHECK,BST_CHECKED	,0		
   	
    	;== Demande Dialogue Modal ============================
			TPrepareDialogue	hDlg,DM_MODAL,dFALSE,dFALSE
    	
    	;== Creation de l'image SOURCE a la taille de la selection ============================
    	; Si pas de selection, le rectangle defini l'image complete
    	; Les Rectangles Delphi sont relatifs a l'origine
			mov			eax,PStruct.SelRect.right
     	sub			eax,PStruct.SelRect.left
     	mov			Img.piWidth,eax
     	mov			eax,PStruct.SelRect.bottom
     	sub			eax,PStruct.SelRect.top
     	mov			Img.piHeight,eax
			TCreateDBmp	Img
			.if Img.piBitmap == 0
				TEndFilter
				return	0
			.endif
			
			mov			IsInit,1			; Permetre l'affichage
			return TRUE	
    	;== Fin de WM_INITDIALOG ============================

		;== WM_COMMAND ======================
    .elseif uMsg == WM_COMMAND
			
			;== BOUTON ANNULER ======================
    	.if wParam == IDC_BUTTON2
    		jmp		ExitDlgBox
    	
			;== BOUTON OK ======================
    	.elseif wParam == IDC_BUTTON1
    		mov		RetValue,1
    		jmp		ExitDlgBox


			;== CHECKBOX Rouge ======================
    	.elseif wParam == IDC_CHECKBOX1
    		invoke 	SendMessage,CHECKBOX1,BM_GETCHECK,0,0		
				.if eax == BST_UNCHECKED
					or			Couche,1 	
				.elseif eax == BST_CHECKED	
					and			Couche,0FFFFFFFEh 	
    		.endif	
				invoke	Affiche
    		
			;== CHECKBOX Vert ======================
    	.elseif wParam == IDC_CHECKBOX2
    		invoke 	SendMessage,CHECKBOX2,BM_GETCHECK,0,0		
				.if eax == BST_UNCHECKED
					or			Couche,2 	
				.elseif eax == BST_CHECKED	
					and			Couche,0FFFFFFFDh 	
    		.endif	
				invoke	Affiche
    		
	
			;== CHECKBOX Bleu ======================
    	.elseif wParam == IDC_CHECKBOX3
    		invoke 	SendMessage,CHECKBOX3,BM_GETCHECK,0,0		
				.if eax == BST_UNCHECKED
					or			Couche,4 	
				.elseif eax == BST_CHECKED	
					and			Couche,0FFFFFFFBh 	
    		.endif	
				invoke	Affiche
    		
	
		;== FIN DE WM_COMMAND ======================
			.endif
		;===========================================

		;== WM_CLOSE ======================
    .elseif uMsg == WM_CLOSE
ExitDlgBox:
	   	invoke EndDialog,hWin,RetValue 	; 
		;==================================

		
		;*******************************************************************
		;== FIN DE LA BOUCLE DE MESSAGE:RETOURNE ZERO ======================
    .endif
    return	0

DialogProc endp
;-------------------------------------------------------------------------
;========================================================================
; Affiche
;========================================================================
Affiche PROC uses esi edi ebx

				.if IsInit == 0
					ret
				.endif

    		TRestoreUndoBitmap						; Restaurer l'image
				;== Recuperer la selection (ou l'image entiere)
				TGetSelBitmap	Img.piBitmap
				TGetScanLineDBmp Img,0				; Recupere ScanLine

				mov			esi,Img.piBuffer			; Adresse IMAGE
				mov			ebx,Img.piHeight			; Taille Y Utile en Pixels
				mov			edx,Couche						; Masque de couche
BoucleY:
				mov			edi,esi								; Sauvegarder l'adresse debut de ligne
				mov			ecx,Img.piWidth				; Taille X Utile en Pixels
BoucleX:
				test		edx,4									; Bleu ?
				je			BVert									; Non => Passer a vert
				mov			BYTE PTR [esi],0			; Oui => Bleu a zero
	BVert:
				test		edx,2									; Vert ?
				je			BRouge								; Non => Passer a Rouge
				mov			BYTE PTR [esi+1],0		; Oui => Vert a zero
	BRouge:
				test		edx,1									; Rouge ?
				je			PixelSuivant					; Non => Pixel Suivant
				mov			BYTE PTR [esi+2],0		; Oui => Rouge a zero

PixelSuivant:
				add			esi,3									; Pixel suivant
				loop		BoucleX								; Refaire si NonZero

LigneSuivante:				
				mov			esi,edi									; Recupere adresse debut de ligne
				sub			esi,Img.piScanlineSize	; Ligne suivante (bitmap la tete en bas!)
				dec			ebx											; Compteur ligne -1
				jne			BoucleY									; Refaire si NonZero
				
				;==== ACTUALISATION DE L'IMAGE => Valider modif dans photofiltre
				TSetSelBitmap	Img.piBitmap,SF_AUTO
				ret
Affiche ENDP
;-------------------------------------------------------------------------

;========================================================================
; COPIE UNE CHAINE DANS UNE AUTRE DE TAILLE FIXE
;========================================================================
szCopyStr PROC uses esi edi Destination:DWORD,Origine:DWORD
	invoke	lnstr,Origine
	or			eax,eax
	je			Fini
	mov			ecx,eax
	mov			esi,Origine
	mov			edi,Destination
	rep			movsb
Fini:
	ret
szCopyStr ENDP
;-------------------------------------------------------------------------

; ########################################################################
; FONCTIONS EXPORTES
; ########################################################################
;-------------------------------------------------------------------------
RegisterPluginHeader proc
	mov	eax,offset PHeader
	ret
RegisterPluginHeader endp
;-------------------------------------------------------------------------
RegisterPluginStruct proc
	mov eax,offset PStruct
	ret
RegisterPluginStruct endp
;-------------------------------------------------------------------------
RegisterCompatibility proc 
	mov eax,NOK_DELPHI
	ret
RegisterCompatibility endp
;-------------------------------------------------------------------------
RegisterPluginGlyph	Proc
invoke	LoadBitmap,hInstance,600
ret
RegisterPluginGlyph	endp
;-------------------------------------------------------------------------

; ########################################################################
End DllEntry
; ########################################################################
