//---------------------------------------------------------------------------
#include <windows.h>
#include "Plugin.h"

//---------------------------------------------------------------------------
#define DLLEXPORT __declspec(dllexport) __stdcall

PPluginHeader DLLEXPORT RegisterPluginHeader(void);
PPluginStruct DLLEXPORT RegisterPluginStruct(void);
PPluginLanguage DLLEXPORT RegisterPluginLanguage(void);
int DLLEXPORT RegisterCompatibility(void);
int DLLEXPORT Execute(void);

//---------------------------------------------------------------------------
int DLLEXPORT Execute(void)
{
  int i,j;
  TPlgImage Image;
  char *Buffer;

  Image.piWidth = GetSelWidth();
  Image.piHeight = GetSelHeight();
  CreateDBmp(&Image); // cration du bitmap Delphi
  // copie la slection dans le bitmap
  GetSelBitmap(&Image);
  // parcourt chaque ligne
  for (i = 0; i < Image.piHeight; i++)
  {
    Buffer = GetScanLineDBmp(&Image, i);
    for (j = 0; j < Image.piWidth * 3; j++)
    {
      *(Buffer++)=*(Buffer) ^ 255;
    }
  }
  SetSelBitmap(&Image,soAuto);
  FreeDBmp(&Image);
  EndFilter;
}

//-------------------------------------------------------------------------
PPluginHeader DLLEXPORT RegisterPluginHeader(void)
{
  SetHeaderCaption("Demo XOr");
  SetHeaderVersion("1.0");
  SetHeaderAuthor("HeaderAuthor");
  SetHeaderComment("Cration d'un effet XOr - Demo C");
  SetHeaderPluginType(ptFilter);
  SetHeaderMenuOptions(moImageTiff|moSelected);
  return (&PluginHeader);
}

//-------------------------------------------------------------------------
PPluginStruct DLLEXPORT RegisterPluginStruct(void)
{
  return (&PluginStruct);
}

//-------------------------------------------------------------------------
int DLLEXPORT RegisterCompatibility(void)
{
  return (NON_DELPHI);
}

//-------------------------------------------------------------------------
PPluginLanguage DLLEXPORT RegisterPluginLanguage(void)
{
  return (&PluginLanguage);
}

