; #########################################################################
; Ce code source est donn  titre purement INFORMATIF, tel quel et je dcline 
; toutes responsabilits quand  l'utilisation que vous pourriez en faire.  
; Il est destin  apprhender l'accs aux plugin PhotoFiltre en assembleur.
; Il n'est pas optimis et ne vrifie aucun retour de fonction. 
; Vous pouvez le modifier  votre convenance.
; ATTENTION : NECESSITE la version 5.6 MINIMUM de PhotoFiltre qui est disponible sur le site
; http://www.photofiltre.com/  (Copyright 2001-2004 Antonio Da Cruz)
; Voir sur le site: Plugins->Autorisation de dveloppement
; #########################################################################


;********************************************************************
; MACRO PhotoFiltre (A COMPLETER SI BESOIN) 
;********************************************************************
TBeginFilter	MACRO IdentNom,Sablier
	push     Sablier	; VRAI = 1
  push     IdentNom 
  call     PStruct.BeginFilter ; BeginFilter(string,Bool)
ENDM
;-------------------
TEndFilter 		MACRO 
	call     PStruct.EndFilter
ENDM
;-------------------
TGetBitmap	MACRO TBitmapIn
	push     TBitmapIn	
  call     PStruct.GetBitmap 
ENDM
;-------------------
TGetSelBitmap	MACRO TBitmapIn
	push     TBitmapIn	
  call     PStruct.GetSelBitmap 
ENDM
;-------------------
TSetBitmap	MACRO TBitmapIn
	push     TBitmapIn	
  call     PStruct.SetBitmap 
ENDM
;-------------------
TSetSelBitmap	MACRO TBitmapIn,SelectOption
	push     SelectOption	
	push     TBitmapIn	
  call     PStruct.SetSelBitmap 
ENDM
;-------------------
TRestoreUndoBitmap	MACRO 
	push     0	
  call     PStruct.SetBitmap 
ENDM
;-------------------
TGetPlugInPath	MACRO PlPath,Taille
  push			Taille
  push			PlPath
  call     	PStruct.GetPluginPath
ENDM
;-------------------
TPrepareDialogue	MACRO HandleF,DialogOption,MainFormCenter,CloseWaiting
  push			CloseWaiting		; CloseWaiting
  push			MainFormCenter	; MainFormCenter
  push			DialogOption		; TDialogOption DM_MODAL = 0;DM_PREVIEW = 1;DM_COLOR_PICKER = 2;
	push			HandleF					; Handle de la feuille
  call     	PStruct.PrepareDialogue
ENDM
;-------------------
TCreateDBmp	MACRO StructureBitmap
  push			offset StructureBitmap
  call     	PStruct.CreateDBmp
ENDM
;-------------------
TFreeDBmp	MACRO StructureBitmap
  push			offset StructureBitmap
  call     	PStruct.FreeDBmp
ENDM
;-------------------
TGetScanLineDBmp	MACRO StructureBitmap,Row
  push			Row
  push			offset StructureBitmap
  call     	PStruct.GetScanLineDBmp
ENDM
;-------------------
TReleaseHandleDBmp	MACRO StructureBitmap
  push			offset StructureBitmap
  call     	PStruct.ReleaseHandleDBmp
ENDM
;-------------------
;********************************************************************
; CONSTANTES PhotoFiltre 
;********************************************************************
.CONST
  RGBColorCount = 256 * 256 * 256 ; 16 millions de couleurs
  MaxLongStr = 256;
  MaxShortStr = 64;

  ; Compatibilit Delphi/Non Delphi
  OK_DELPHI = 1
  NOK_DELPHI = 2
  
  ; type du plugin
  PT_FILTER = 0;
  PT_IMAGE = 1;
  PT_FILE_IMPORT = 2;
  PT_FILE_EXPORT = 3;
  PT_TOOL = 4;

  ; mode de dialogue
  DM_MODAL = 0;
  DM_PREVIEW = 1;
  DM_COLOR_PICKER = 2;

  ; flags de slection
  SF_AUTO = 0;
  SF_NONE = 1;

  ; flags pour la cration d'image
  IF_CREATE = 0;
  IF_FILE = 1;

  ; flags pour l'activation du menu
  MF_RGB_COLORS = 00000001h;
  MF_INDEXED_COLORS = 00000002h;
  MF_TRANSPARENT = 00000004h;
  MF_NOT_TRANSPARENT = 00000008h;
  MF_SELECTED = 00000010h;
  MF_NOT_SELECTED = 00000020h;
  MF_NEED_IMAGE = 00000040h;
  MF_NEED_MORE_THAN_ONE_IMAGE = 00000080h;
  ; test sur l'extension du fichier en cours
  MF_IMAGE_JPEG = 00010000h;
  MF_IMAGE_GIF = 00020000h;
  MF_IMAGE_PNG = 00040000h;  
  MF_IMAGE_BMP = 00080000h;
  MF_IMAGE_TIFF = 00100000h;
  MF_IMAGE_PFS = 00200000h;

;=== CONSTANTES FALSE/TRUE POUR DELPHI
dTRUE          EQU 1
dFALSE         EQU 0

;********************************************************************
; DESCRIPTION DE LA STRUCTURE D'IMAGE
;********************************************************************
SIMAGE     				STRUCT
	piSize					DWORD ?			; Taille de la structure
	piWidth					DWORD ?			; Largeur en pixels
  piHeight				DWORD ?			; Hauteur en pixels
  piWidthSize			DWORD ?			; Taille X utile en octets (piWidth * piByteCount)
  piScanlineSize	DWORD ?			; Scanline complete en octets (alignement 32 bits)
  piByteCount			DWORD ?			; Nombre d'octets par pixels
  piDataSize			DWORD ?			; Taille totale du buffer (piScanlineSize * piHeight)
  piBuffer				DWORD ?			; Adresse du buffer de travail
  piBitmap				DWORD ?			; Pointeur vers un objet TBitmap
  piHandle				DWORD ?			; Handle du bitmap Windows
SIMAGE     				ENDS

;********************************************************************
; DESCRIPTION DES STRUCTURES PHOTOFILTRE
;********************************************************************
;=== STRUCTURE D'ENTETE DU PLUGIN 
PluginHeader 			STRUCT
	Caption					db	MaxShortStr dup(0),0
  Version					db	MaxShortStr dup(0),0
  PluginType			dd	?
  Author					db	MaxShortStr dup(0),0
  Commentaire			db	MaxShortStr dup(0),0
	Reserve					db	MaxShortStr dup(0),0	; non utilis
	Flags						dd	?											; pour l'activation du menu
PluginHeader 			ENDS

;=== STRUCTURE D'EXECUTION DU PLUGIN 
PluginStruct 					STRUCT
	MainHandle					dd	0
  ImageExists					dd	0	;
  Selected						dd	0	;
  SelRect							RECT <>
  ImgRect							RECT <>
  XP_ThemesEnabled		dd	0	;   
  BeginFilter					dd	0	; 
  EndFilter						dd	0	; 
  GetBitmap						dd	0	;
  SetBitmap						dd	0	; 
  GetSelBitmap				dd	0	; 
  SetSelBitmap				dd	0	; 
  GetTransparentColor	dd	0	;
  SetTransparentColor	dd	0	; 
  GetColorCount				dd	0	; 
  SetColorCount				dd	0	; 
  NewImage						dd	0	;
  ShowForm						dd	0	;
  SetAlphaBlend				dd	0	; 
  DrawSelBorder				dd	0	; 
  GetSelMask					dd	0	; 
  ResetSaveMenu				dd	0	; 
  GetImgFileName			dd	0	; 
  GetExePath					dd	0	; 
  GetOpenPath					dd	0	; 
  GetSavePath					dd	0	; 
  GetPluginPath				dd	0	; 
  GetIniFile					dd	0	; 
  SetImgFileName			dd	0	; 
  GetBitmapByName			dd	0	; 
  GetThumb						dd	0	; 
  GetThumbByName			dd	0	;
  EnumImages					dd	0	; 
	PrepareDialogue			dd	0	;
	CreateDBmp					dd	0	; 
	FreeDBmp						dd	0	; 
	ReleaseHandleDBmp		dd	0	; 
	GetScanLineDBmp			dd	0	;
	Reserve1						dd	0	;
	Reserve2						dd	0	;
	Reserve3						dd	0	;
	Reserve4						dd	0	;
	Reserve5						dd	0	;
PluginStruct		ENDS

